/*
	Licensed Material - Property of IBM

	(C) Copyright 2015, 2016 IBM Corp.

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/


var path = require('path');
var strings = require('ibm-strings');
var localizedMessages = strings({locales: path.resolve(__dirname, '..', 'nls')});

module.exports = {
  INVALIDCMD:{errno:110,code:"INVALIDCMD",description:localizedMessages.invalidCommand},
  NO_PROCESS:{errno:111,code:"NO_PROCESS",description:localizedMessages.noProcess},
  BADARGUMENTS:{errno:112,code:"BADARGUMENTS",description:localizedMessages.errorArguments},
  SERVERNOTRUNNING:{errno:113,code:'SERVERNOTRUNNING',description:localizedMessages.serverNotRunning},
  NORUNTIMESEXIST:{errno:114,code:'NORUNTIMESEXIST',description:localizedMessages.serverRuntimeMessage},
  SVRDOESNOTEXISTS:{errno:115,code:'SVRDOESNOTEXISTS',description:localizedMessages.serverProfileDoesNotExist},
  MISSINGSERVERPROFILES:{errno:116,code:'MISSINGSERVERPROFILES',description:localizedMessages.errorServerProfileMissing},
  INVALIDTIMEOUT:{errno:117,code:'INVALIDTIMEOUT',description:localizedMessages.invalidTimeout},
  INVALIDSERVERPROFILENAME:{errno:118,code:'INVALIDSERVERPROFILENAME',description:localizedMessages.invalidServerProfileName},
  SVREXISTS:{errno:119,code:'SVREXISTS',description:localizedMessages.serverProfileExists},
  INVALIDSERVERNAME:{errno:120,code:'INVALIDSERVERNAME',description:localizedMessages.invalidServerName},
  SVRUNREACHABLE:{errno:121,code:'SVRUNREACHABLE',description:localizedMessages.errorServerUnreachable},
  ERRGETRUNTIME:{errno:122,code:'ERRGETRUNTIME',description:localizedMessages.errorRetrieveRuntime},
  ERRDEFAULTSERVERCANNOTBEDELETED:{errno:123,code:'ERRDEFAULTSERVERCANNOTBEDELETED',description:localizedMessages.serverDefaultCanNotBeDeleted},
  CANNOTRENAMELOCAL:{errno:124,code:'CANNOTDELETELOCAL',description:localizedMessages.canNotRenameLocal},
  MISSINGSVRACTION:{errno:125,code:'MISSINGSVRACTION',description:localizedMessages.missingServerAction},
  INVALIDSVRACTION:{errno:126,code:'INVALIDSVRACTION',description:localizedMessages.invalidServerAction},
  MISSINGSERVERDEFINITION:{errno:127,code:'MISSINGSERVERDEFINITION',description:localizedMessages.missingServerDefinition},
  ERRMISSINGSERVERURL:{errno:128,code:'ERRMISSINGSERVERURL',description:localizedMessages.serverProfileURLMissing},
  BADSERVERURL:{errno:129,code:'BADSERVERURL',description:localizedMessages.badServerURL},
  BADSERVERARGS:{errno:130,code:"BADSERVERARGS",description:localizedMessages.badServerArgs},
  ERRGETSERVER:{errno:131,code:'ERRGETSERVER',description:localizedMessages.errorReadServers},
  MDOSERVERCOMMANDFAILED:{errno:132,code:"MDOSERVERCOMMANDFAILED",description:localizedMessages.mdoServerCommandFailed},
  INVALIDHELPCMD:{errno:133,code:"INVALIDHELPCMD",description:localizedMessages.helpInvalidCommand},
  RUNTIMENOTFOUND:{errno:134,code:'RUNTIMENOTFOUND',description:localizedMessages.runtimeNotFound},
  PROFILENOTFOUND:{errno:135,code:'PROFILENOTFOUND',description:localizedMessages.profileNotFound},
  ERRWRITEFILE:{errno:136,code:'ERRWRITEFILE',description:localizedMessages.errorCannotWriteFile},
  INVALIDCONFIGKEY:{errno:137,code:"INVALIDCONFIGKEY",description:localizedMessages.invalidConfigKey},
  INVALIDCONFIGVALUE:{errno:138,code:"INVALIDCONFIGVALUE",description:localizedMessages.invalidConfigValue},
  INVALIDARGS:{errno:139,code:"INVALIDARGS",description:localizedMessages.invalidArgs},
  ILLEGALPATH:{errno:140,code:'ILLEGALPATH',description:localizedMessages.illegalPath},
  FILENOEXISTS:{errno:141,code:'FILENOEXISTS',description:localizedMessages.fileNoExists},
  INVALIDVALUEFORMAT:{errno:143,code:'INVALIDVALUEFORMAT',description:localizedMessages.invalidValueFormat},
  CANNOTVERIFYCONFIG:{errno:144,code:'CANNOTVERIFYCONFIG',description:localizedMessages.cannotVerifyConfig},
  NOPLATFORMSDETECTED:{errno:145,code:'NOPLATFORMSDETECTED',description:localizedMessages.noPlatformsDetected},
  REQUIRES_CORDOVA_PROJ:{errno:146,code:"REQUIRES_CORDOVA_PROJ",description:localizedMessages.requiresCordovaProj},
  REQUIRES_CORDOVA_PLATFORM:{errno:147,code:"REQUIRES_CORDOVA_PLATFORM",description:localizedMessages.requiresCordovaPlatform},
  MORE_THAN_ONE_MODE_SPECIFIED:{errno:148,code:"MORE_THAN_ONE_MODE_SPECIFIED",description:localizedMessages.moreThanOneModeSpecified},
  NO_PLATFORM_SPECIFIED:{errno:149,code:"NO_PLATFORM_SPECIFIED",description:localizedMessages.noPlatformSpecified},
  INVALID_PREVIEW_TYPE:{errno:150,code:"INVALID_PREVIEW_TYPE",description:localizedMessages.invalidPreviewType},
  NOEXTENSIONSFOUND:{errno:151,code:"NOEXTENSIONSFOUND",description:localizedMessages.noExtensionsFound},
  NOPLATFORMDETECTED:{errno:152,code:'NOPLATFORMDETECTED',description:localizedMessages.noPlatformDetected},
  INVALIDACTION: {errno: 153, code: "INVALIDACTION", description: localizedMessages.invalidAction},
  MISSINGNAME: {errno: 154, code: "MISSINGNAME", description: localizedMessages.missingName},
  INVALIDNAME: {errno: 155, code: "INVALIDNAME", description: localizedMessages.invalidName},
  FILEEXISTS: {errno: 156, code: "FILEEXISTS", description: localizedMessages.fileExists},
  MISSINGPACKAGENAME: {errno: 157, code: "MISSINGPACKAGENAME", description: localizedMessages.missingPackageName},
  INVALIDPACKAGEPERIOD: {errno: 158, code: "INVALIDPACKAGEPERIOD", description: localizedMessages.invalidPackagePeriod},
  MISSINGGROUPID: {errno: 159, code: "MISSINGGROUPID", description: localizedMessages.missingGroupID},
  INVALIDGROUPPERIOD: {errno: 160, code: "INVALIDGROUPPERIOD", description: localizedMessages.invalidGroupPeriod},
  INVALIDID: {errno: 161, code: "INVALIDID", description: localizedMessages.invalidID},
  MISSINGADAPTERTYPE: {errno: 162, code: "MISSINGADAPTERTYPE", description: localizedMessages.missingAdapterType},
  INVALIDADAPTERTYPE: {errno: 163, code: "INVALIDADAPTERTYPE", description: localizedMessages.invalidAdapterType},
  CANNOTADDPACKAGENAME: {errno: 164, code: "CANNOTADDPACKAGENAME", description: localizedMessages.cannotAddPackageName},
  INVALIDADAPTERPARAMS: {errno: 165, code: "INVALIDADAPTERPARAMS", description: localizedMessages.invalidAdapterParams},
  ADAPTERCREATEERROR: {errno: 166, code: "ADAPTERCREATEERROR", description: localizedMessages.adapterCreateError},
  MISSINGACTION: {errno: 167, code: "MISSINGACTION", description: localizedMessages.missingAction},
  NONADAPTERFOLDER: {errno: 168, code: "NONADAPTERFOLDER", description: localizedMessages.nonAdapterFolder},
  ADAPTERBUILDERROR: {errno: 169, code: "ADAPTERBUILDERROR", description: localizedMessages.adapterBuildError},
  UPDATEFILENOTVALIDZIPFILE: {errno: 170, code: "UPDATEFILENOTVALIDZIPFILE", description: localizedMessages.updateFileNotValidZipFile},
  FILESPECIFIEDWITHBUILD: {errno: 171, code: "FILESPECIFIEDWITHBUILD", description: localizedMessages.fileSpecifiedWithBuildErr},
  WINDOWSNOTSUPPORTEDWEBUPDATE: {errno: 172, code: "WINDOWSNOTSUPPORTEDWEBUPDATE", description: localizedMessages.windowsNotSupportedWebUpdate},
  INVALIDFILENAMEWEBUPDATE: {errno: 173, code: "INVALIDFILENAMEWEBUPDATE", description: localizedMessages.invalidFileNameWebUpdate},
  CORDOVAMFPPLUGINNOTINSTALLED: {errno: 174, code: "CORDOVAMFPPLUGINNOTINSTALLED", description: localizedMessages.cordovaMfpPluginNotInstalled},
  SCRIPTNOTPRESENT: {errno: 175, code: "SCRIPTNOTPRESENT", description: localizedMessages.scriptNotPresent},
  ENCRYPTPATHDOESNOTEXIST: {errno: 176, code: "ENCRYPTPATHDOESNOTEXIST", description: localizedMessages.encryptPathDoesNotExist},
  NOTINAVALIDPROJECT: {errno: 177, code: "NOTINAVALIDPROJECT", description: localizedMessages.notInAValidProject},
  APPNOTREGISTEREDBEFOREDEPLOYMENT: {errno: 178, code: "APPNOTREGISTEREDBEFOREDEPLOYMENT", description: localizedMessages.appNotRegisteredBeforeDeployment},
  MISSINGMVN: {errno: 179, code: "MISSINGMVN", description: localizedMessages.missingMVN},
  MISSINGURL: {errno: 180, code: "MISSINGURL", description: localizedMessages.missingURL},
  MISSINGUSERNAME: {errno: 181, code: "MISSINGUSERNAME", description: localizedMessages.missingUsername},
  MISSINGPASSWORD: {errno: 182, code: "MISSINGPASSWORD", description: localizedMessages.missingPassword},
  ADAPTERDEPLOYERROR: {errno: 183, code: "ADAPTERDEPLOYERROR", description: localizedMessages.adapterDeployError},
  NOTOKEN: {errno: 184, code: "NOTOKEN", description: localizedMessages.noToken},
  INVALID_APP_CONFIG_KEY:{errno:185,code:"INVALID_APP_CONFIG_KEY",description:localizedMessages.invalidAppConfigKey},
  INVALID_APP_CONFIG_VALUE:{errno:186,code:"INVALID_APP_CONFIG_VALUE",description:localizedMessages.invalidAppConfigValue},
  CANNOT_PARSE_FILE:{errno:187,code:"CANNOT_PARSE_FILE",description:localizedMessages.cannotParseFile},
  MUSTBECORDOVAPROJECT: {errno: 188, code: "MUSTBECORDOVAPROJECT", description: localizedMessages.mustBeCordovaProject},
  ERRORCREATINGZIPFILE: {errno: 189, code: "ERRORCREATINGZIPFILE", description: localizedMessages.errorCreatingZipFile},
  FAILURECREATINGARCHIVE: {errno: 190, code: "FAILURECREATINGARCHIVE", description: localizedMessages.failureCreatingArchive},
  OUTPUTSTREAMFAILURE: {errno: 191, code: "OUTPUTSTREAMFAILURE", description: localizedMessages.outputStreamFailure},
  RUNTIMEWITHOUTSERVER:{errno:192,code:"RUNTIMEWITHOUTSERVER",description:localizedMessages.runtimeWithoutServer},
  NOADAPTERSONSERVER:{errno:193,code:"NOADAPTERSONSERVER",description:localizedMessages.noAdaptersOnServer},
  INVALIDJSON:{errno:194,code:'INVALIDJSON',description:localizedMessages.invalidJSONFormat},
  CALLFORMAT:{errno:195,code:'CALLFORMAT',description:localizedMessages.invalidCallFormat},
  INVALIDPARAM:{errno:196,code:"INVALIDPARAM",description:localizedMessages.headerParamsError},
  ADAPTERNOPROCEDURES:{errno:197,code:'ADAPTERNOPROCEDURES',description:localizedMessages.adapterHasNoProcedures},
  INVALIDCONFIDENTIALCLIENT:{errno:198, code:'INVALIDCONFIDENTIALCLIENT',description:localizedMessages.invalidConfidentialClient},
  ADAPTERNOTFOUND:{errno:199, code:'ADAPTERNOTFOUND',description:localizedMessages.adapterNotFound},
  CORDOVANOTINSTALLED:{errno:200, code:'CORDOVANOTINSTALLED',description:localizedMessages.cordovaNotFound},
  BROWSERSYNCFAILED:{errno:201, code:'BROWSERSYNCFAILED',description:localizedMessages.browserSyncFailed},
  NO_CLIENT_PROPERTIES:{errno:202, code:'NO_CLIENT_PROPERTIES', description:localizedMessages.noClientProperties},
  PREVIEWPORTINUSE:{errno:203, code:'PREVIEWPORTINUSE', description:localizedMessages.previewPortInUse},
  NORUNTIMECONFIGEXIST:{errno:204,code:'NORUNTIMECONFIGEXIST',description:localizedMessages.serverRuntimeConfigMessage},
  // NOTE:Error code 254 & 255 reserved for app-checksum failure and checksum,encrypt,prepare script failures (respectively)
  // Please maintain order by "errno" when adding new errors!
  INVALIDPLATFORMVERSION: {errno: 254, code: "INVALIDPLATFORMVERSION", description: localizedMessages.invalidPlatformVersion},
  ERRORDURINGEXTERNALSCRIPT: {errno: 255, code: "ERRORDURINGEXTERNALSCRIPT", description: localizedMessages.errorDuringExternalScript},
  ADAPTERPUSHERROR: {errno: 256, code: "ADAPTERPUSHERROR", description: localizedMessages.adapterPushError},
  ADAPTERPULLERROR: {errno: 257, code: "ADAPTERPULLERROR", description: localizedMessages.adapterPullError},
  BROWSERNOTSUPPORTEDWEBUPDATE: {errno: 258, code: "BROWSERNOTSUPPORTEDWEBUPDATE", description: localizedMessages.browserNotSupportedWebUpdate},
  BROWSERNOTSUPPORTMBS: {errno: 259, code: "BROWSERNOTSUPPORTMBS", description: localizedMessages.browserNotSupportMBS}
};
